;*************************************************************************
;									 *
;*				ATMEGA Bootloader			 *
;*									 *
;*************************************************************************
.nolist
.include "device.inc"
.include "bootload.inc"
.list

.equ	base	= SECONDBOOTSTART
	.org	base
	rjmp	init
	.org	base + OVF1addr
	rjmp	OVF1int
	.org	base + URXCaddr
	rjmp	URXCint
	.org	base + NOINTaddr	;end of interrupt vector table
init:
.include"init.inc"
;
;------------------------------------------------------------------------
	rcall	abaud			;detect baud rate
	rcall	set_baud		;set baud rate

main:	cbr	flags, 1<<f_error	;clear error
	rcall	rx_command		;Command received ?
	brcc	main
	rcall	exec_command		;Command execute
	ldi	a0, key_failed		;execution failed
	sbrs	flags, f_error		;test
	ldi	a0, key_done		;execution successful
	sbrc	flags, f_enable
	rcall	putchar			;send command execution status
	rjmp	main
;-------------------------------------------------------------------------
.include"uart.inc"
.include"commexec.inc"
.include"asc2hex.inc"
.include"commands.inc"
.include"read.inc"
.include"program.inc"
.include"userprog.inc"
.include"abaud.inc"
;-------------------------------------------------------------------------
