.set MEGA8		= 0
.set MEGA16		= 1
.set MEGA162	= 2
.set MEGA323	= 3
.set MEGA128	= 4

.set BOOT_DEVICE = MEGA128


;*******************************************************************************
.if BOOT_DEVICE == MEGA8
	.include "m8def.inc"
	.equ	signature	= 0x1E9307	;Mega8
	.equ	RAMSTART	= 0x60
	.equ	NOINTaddr	= 0x13			; no more interrupt vectors
	.equ	UART_IN		= PIND
	.equ	RXD				= PD0

;*******************************************************************************
.elif	BOOT_DEVICE == MEGA16
	.include "m16def.inc"
	.equ	signature	= 0x1E9403	;Mega16
	.equ	RAMSTART	= 0x60
	.equ	NOINTaddr	= 0x2A			;no more interrupt vectors
	.equ	UART_IN		= PIND
	.equ	RXD				= PD0
	.equ	RWWSRE		= ASRE

;*******************************************************************************
.elif	BOOT_DEVICE == MEGA162
	.include "m162def.inc"
	.equ	signature	= 0x1E9404	;Mega162
	.equ	RAMSTART	= 0x100
	.equ	NOINTaddr	= 0x38
	.equ	UART_IN		= PIND
	.equ	RXD				= PORTD0
	.equ	OVF1addr	= TIMER1OVFaddr
	.equ	URXCaddr	= USART0RXCaddr
	.equ	UBRRL			= UBRR0L
	.equ	UBRRH			= UBRR0H
	.equ	UCSRA			= UCSR0A
	.equ	URSEL			= URSEL0
	.equ	UCSZ1			=	UCSZ01
	.equ	UCSZ0			= UCSZ00
	.equ	UCSRC			= UCSR0C
	.equ	UCSRB			=	UCSR0B

;*******************************************************************************
.elif	BOOT_DEVICE == MEGA323
	.include "m323def.inc"
	.equ	signature	= 0x1E9501	;Mega323
	.equ	RAMSTART	= 0x60
	.equ	NOINTaddr	=	0x2A			; no more interrupts
	.equ	UART_IN		= PIND
	.equ	RXD				= PD0
	.equ	RWWSRE		= ASRE

;*******************************************************************************
.elif	BOOT_DEVICE == MEGA128
	.include "m128def.inc"
	.equ	signature	= 0x1E9702	;Mega128
	.equ	RAMSTART	= 0x100
	.equ	NOINTaddr	=	0x44		  ;no more interrupt vectors
	.equ	URXCaddr	= URXC0addr
	.equ	UART_IN		= PINE
	.equ	RXD				= PE0
	.equ	UBRRL			= UBRR0L
	.equ	UBRRH			= UBRR0H		; extended I/O space !
	.equ	UCSRA			= UCSR0A
	.equ	UCSRC			= UCSR0C		; extended I/O space !
	.equ	UCSRB			=	UCSR0B
	.equ	UDR				= UDR0

;*******************************************************************************
.else
	.error "Device is not supported by this bootloader! (see device.inc)"
.endif


.macro out_ext						; macro for the extended I/O Space ...
	.if	BOOT_DEVICE == MEGA128
		sts	@0, @1
	.else
		out @0, @1
	.endif
.endmacro

.macro in_ext							; macro for the extended I/O Space ...
	.if	BOOT_DEVICE == MEGA128
		lds	@0, @1
	.else
		in @0, @1
	.endif
.endmacro
